//: C11:WaxOMatic.cpp {RunByHand}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// základní spolupráce vláken
//{L} ZThread
#include <iostream>
#include <string>
#include "zthread/Thread.h"
#include "zthread/Mutex.h"
#include "zthread/Guard.h"
#include "zthread/Condition.h"
#include "zthread/ThreadedExecutor.h"
using namespace ZThread;
using namespace std;

class Auto {
  Mutex lock;
  Condition condition;
  bool voskNanesen;
public:
  Auto() : condition(lock), voskNanesen(false) {}
  void navoskovano() {
    Guard<Mutex> g(lock);
    voskNanesen = true; // Připraveno k leštění
    condition.signal();
  }
  void vylesteno() {
    Guard<Mutex> g(lock);
    voskNanesen = false; // Ready for another coat of wax
    condition.signal();
  }
  void cekatNaVoskovani() {
    Guard<Mutex> g(lock);
    while(voskNanesen == false)
      condition.wait();
  }
  void cekatNaLesteni() {
    Guard<Mutex> g(lock);
    while(voskNanesen == true)
      condition.wait();
  }
};

class Voskovani : public Runnable {
  CountedPtr<Auto> automobil;
public:
  Voskovani(CountedPtr<Auto>& c) : automobil(c) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        cout << "Vosk nanesen!" << endl;
        Thread::sleep(200);
        automobil->navoskovano();
        automobil->cekatNaLesteni();
      }
    } catch(Interrupted_Exception&) { /* konec */ }
    cout << "Ukončování procesu nanášení vosku" << endl;
  }
};

class Lesteni : public Runnable {
  CountedPtr<Auto> automobil;
public:
  Lesteni(CountedPtr<Auto>& c) : automobil(c) {}
  void run() {
    try {
      while(!Thread::interrupted()) {
        automobil->cekatNaVoskovani();
        cout << "Vyleštěno!" << endl;
        Thread::sleep(200);
        automobil->vylesteno();
      }
    } catch(Interrupted_Exception&) { /* Konec */ }
    cout << "Ukončování procesu leštění..." << endl;
  }
};

int main() {
  cout << "Ukončit stiskem klávesy <Enter>" << endl;
  try {
    CountedPtr<Auto> automobil(new Auto);
    ThreadedExecutor executor;
    executor.execute(new Lesteni(automobil));
    executor.execute(new Voskovani(automobil));
    cin.get();
    executor.interrupt();
  } catch(Synchronization_Exception& e) {
    cerr << e.what() << endl;
  }
} ///:~
